"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _immutable = require("immutable");

var _actionTypes = require("../constants/action-types");

var _update = require("../lib/update");

var initialState = (0, _immutable.Map)();

var entities = function entities() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  if (action.type === _actionTypes.RESET) {
    return 'entities' in action ? action.entities : initialState;
  } else if (action.type === _actionTypes.MUTATE_START && action.optimisticEntities) {
    return state.merge(action.optimisticEntities);
  } else if (action.type === _actionTypes.MUTATE_FAILURE && action.rolledBackEntities) {
    return state.merge(action.rolledBackEntities);
  } else if (action.type === _actionTypes.REQUEST_SUCCESS || action.type === _actionTypes.MUTATE_SUCCESS) {
    return state.merge(action.entities);
  } else if (action.type === _actionTypes.UPDATE_ENTITIES) {
    return state.merge((0, _update.optimisticUpdateEntities)(action.update, state));
  } else {
    return state;
  }
};

var _default = entities;
exports["default"] = _default;